# coding: utf-8

"""
    FINBOURNE Luminesce Web API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.14.755
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from luminesce.configuration import Configuration


class ErrorHighlightResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'errors': 'list[ErrorHighlightItem]',
        'sql_with_marker': 'str'
    }

    attribute_map = {
        'errors': 'errors',
        'sql_with_marker': 'sqlWithMarker'
    }

    required_map = {
        'errors': 'required',
        'sql_with_marker': 'required'
    }

    def __init__(self, errors=None, sql_with_marker=None, local_vars_configuration=None):  # noqa: E501
        """ErrorHighlightResponse - a model defined in OpenAPI"
        
        :param errors:  The errors within the Sql (required)
        :type errors: list[luminesce.ErrorHighlightItem]
        :param sql_with_marker:  The SQL this is for, with characters indicating the error locations (required)
        :type sql_with_marker: str

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._errors = None
        self._sql_with_marker = None
        self.discriminator = None

        self.errors = errors
        self.sql_with_marker = sql_with_marker

    @property
    def errors(self):
        """Gets the errors of this ErrorHighlightResponse.  # noqa: E501

        The errors within the Sql  # noqa: E501

        :return: The errors of this ErrorHighlightResponse.  # noqa: E501
        :rtype: list[luminesce.ErrorHighlightItem]
        """
        return self._errors

    @errors.setter
    def errors(self, errors):
        """Sets the errors of this ErrorHighlightResponse.

        The errors within the Sql  # noqa: E501

        :param errors: The errors of this ErrorHighlightResponse.  # noqa: E501
        :type errors: list[luminesce.ErrorHighlightItem]
        """
        if self.local_vars_configuration.client_side_validation and errors is None:  # noqa: E501
            raise ValueError("Invalid value for `errors`, must not be `None`")  # noqa: E501

        self._errors = errors

    @property
    def sql_with_marker(self):
        """Gets the sql_with_marker of this ErrorHighlightResponse.  # noqa: E501

        The SQL this is for, with characters indicating the error locations  # noqa: E501

        :return: The sql_with_marker of this ErrorHighlightResponse.  # noqa: E501
        :rtype: str
        """
        return self._sql_with_marker

    @sql_with_marker.setter
    def sql_with_marker(self, sql_with_marker):
        """Sets the sql_with_marker of this ErrorHighlightResponse.

        The SQL this is for, with characters indicating the error locations  # noqa: E501

        :param sql_with_marker: The sql_with_marker of this ErrorHighlightResponse.  # noqa: E501
        :type sql_with_marker: str
        """
        if self.local_vars_configuration.client_side_validation and sql_with_marker is None:  # noqa: E501
            raise ValueError("Invalid value for `sql_with_marker`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                sql_with_marker is not None and len(sql_with_marker) < 1):
            raise ValueError("Invalid value for `sql_with_marker`, length must be greater than or equal to `1`")  # noqa: E501

        self._sql_with_marker = sql_with_marker

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ErrorHighlightResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ErrorHighlightResponse):
            return True

        return self.to_dict() != other.to_dict()
